/* CART */
var mycart = mycart || {};
mycart.cart = mycart.cart || {};
mycart.currency = mycart.currency || 'USD';
mycart.currency_symbol = mycart.currency_symbol || '$';
mycart.max_qty = 29;
mycart.currency_selector = '<style>    .recurring_wrapper {     text-align: center;     margin: 20px 0;    }    .recurring_wrapper a {     text-decoration: none;     color: #333 !important;     font-weight: bold;    }    .recurring_wrapper a i {     position: relative;     bottom: -2px;            font-size: 1.2em;    }    .currencies_wrapper {     display: flex;     position: relative;     align-items: center;     justify-content: space-between;     border: 1px solid #ccc;     border-radius: 30px;     width: calc(90% - 32px);     max-width: 125px;     margin: 0 auto 20px auto;     padding: 7px 15px;     cursor: pointer;     color: #333;     z-index: 9;    }    .currencies_wrapper .label {     font-size: 14px;     width: calc(100% - 60px);    }    .currencies_wrapper > ul {     display: none;     position: absolute;     top: 34px;     left: 0;     width: calc(100% - 10px);     padding: 5px;     margin: 0;     border: 1px solid #ccc;     border-radius: 4px;     background: #fff;     font-size: 14px;     line-height: 1.4em;     list-style-type: none;    }    .currencies_wrapper > ul li a {     display: flex;     align-items: center;     justify-content: flex-start;     text-decoration: none;     color: #333 !important;     padding: 5px;     border-radius: 3px;     transition: all 0.25s ease;    }    .currencies_wrapper > ul li a:hover {     background: #e2e7ef;     transition: all 0.25s ease;    }    .currencies_wrapper > ul li a.selected {     background: #527ba9;     transition: all 0.25s ease;     color: #fff !important;           }    .currencies_wrapper > ul li a img {     display: block;      margin-right: 5px;    }    .currencies_wrapper img {     max-width: 30px;    }    .currencies_wrapper.show-dropdown > ul {     display: block;    }    .currencies_wrapper_bg {     position: fixed;     top: 0;     left: 0;     width: 100%;     height: 100%;     z-index: 1;    }    </style>    <div class="currencies_wrapper">     <div class="label">Currency</div>          <div class="selected-currency"><img src="https://d2urhn0mmik6is.cloudfront.net/site/donate/pure-gift/imgs/usflag.png" alt="USD" title="USD" /></div>     <i class="fa fa-caret-down" aria-hidden="true"></i>     <ul><li><a href="#" class="usd selected" data-currency="usd" data-currency-symbol="$" onclick="tp.selectCurrency(\'USD\', \'$\', mycart.setCurrencyFromCart(this)); return false;"><img src="https://d2urhn0mmik6is.cloudfront.net/site/donate/pure-gift/imgs/usflag.png" alt="USD" title="USD" /> United States</a></li><li><a href="#" class="cad" data-currency="cad" data-currency-symbol="CAD $" onclick="tp.selectCurrency(\'CAD\', \'CAD $\', mycart.setCurrencyFromCart(this)); return false;"><img src="https://d2urhn0mmik6is.cloudfront.net/site/donate/pure-gift/imgs/cadflag.png" alt="CAD" title="CAD" /> Canada</a></li><li><a href="#" class="gbp" data-currency="gbp" data-currency-symbol="&#163;" onclick="tp.selectCurrency(\'GBP\', \'&#163;\', mycart.setCurrencyFromCart(this)); return false;"><img src="https://d2urhn0mmik6is.cloudfront.net/site/_images/header/flag_uk.png" alt="GBP" title="GBP" /> UK (GBP)</a></li></ul>    </div>     <script type="text/javascript">    $(function() {     $(".currencies_wrapper").off("click").on("click", function() {      tp.toggleCurrencyDropdown(this);      return false;     });    });    </script>';
mycart.domain = 'www.davidjeremiah.org';

mycart.addToCart = function(elem, qty, settings) {
	var parent = $(elem).closest('.bible');
	var product_code = $(parent).attr('data-productcode');
	if (typeof qty === 'undefined') qty = 1;
	if (typeof settings === 'undefined') settings = {};
	if (typeof settings.replace_qty === 'undefined') settings.replace_qty = false;
	if (typeof settings.callback === 'undefined') settings.callback = function(){};
	
	//check max quantity 
	if (settings.replace_qty) {
		if (qty > mycart.max_qty) {
			alert('For quantities of 30 or more, please call us at 1-877-998-0222.');
			return;
		}
	}
	else {
		if (typeof mycart.cart.contents !== 'undefined' && mycart.cart.contents != null) {
			if (typeof mycart.cart.contents[product_code] !== 'undefined') {
				var current_qty = mycart.cart.contents[product_code].qty;
				if ((current_qty + qty) > mycart.max_qty) {
					alert('For quantities of 30 or more, please call us at 1-877-998-0222.');
					return;
				}
			}
		}
	}
	
	//show update-msg
	var msg = $(parent).find('.update-msg');
	$(msg).css({'visibility':'visible', 'opacity':1});
	setTimeout(function() {
		$(msg).animate({'opacity':0}, 500, function() {
			$(msg).css({'visibility':'hidden'});
		});
	}, 5000);	
	
	tp.addToCart(product_code, qty, {
		replace_qty: settings.replace_qty, 
		callback: function(data) {
			mycart.cart = data;
			mycart.updateCart();
			settings.callback();
		}
	});
}

mycart.updateCart = function() {
	if (typeof mycart.cart.contents === 'undefined') {
		mycart.getCart(function() {
			mycart.updateCart();
		});
		return;
	}
	
	if (typeof mycart.cart.currency !== 'undefined') {
		mycart.setCurrency(mycart.cart.currency, '', {use_ajax:false, currency_symbol: tp.currency_symbol});
	}
	$('.qty.num').html(mycart.cart.item_count);
	$('#mini-cart .total').html(mycart.currency_symbol + mycart.cart.subtotal);
}

mycart.getCart = function(callback) {	
	if (typeof callback === 'undefined') callback = function(){};
	
	tp.getCart({callback:function(data) {
		mycart.cart = data;
		callback();
	}});
}

mycart.showCart = function(settings) {
	if (typeof settings === 'undefined') settings = {};
	if (typeof settings.oneclick_checkout === 'undefined') settings.oneclick_checkout = false;
	if (typeof settings.headline === 'undefined') settings.headline = 'Your Cart';
	
	var html = '';
	var shipping_required = false;
	
	var cart_is_empty = true;
	var contents = mycart.cart.contents;
	var cartData = mycart.cart;
	if (contents === 'undefined') return;
	
	mycart.show_recurring_option = false;
	mycart.show_additional_gift = true;
	var coupon_code_applied = '';
	var bsp_discount_applied = false;
	
	// Christmas Shipping Banner 
	var christmas_shipping_banner = '';
	if ($(".christmas-banner-2").length > 0 && window.location.pathname.indexOf("/store")!=-1) {
		christmas_shipping_banner = $('<div>').append($('#tp_wrapper .christmas-banner-2').clone()).html();
	}
	let itemsArray = [];
	for (var item in contents) {
		if (contents.hasOwnProperty(item)) {
			var obj = contents[item];
			cart_is_empty = false;
			let itemData = new Object();
			let i = 0;
			itemData.item_name = obj.title

			if (obj.hasOwnProperty("stamp")) {
				if(obj.stamp != "") {
					itemData.item_name = itemData.item_name + " " + obj.stamp.trim()
				}
			}

			itemData.item_name = itemData.item_name.replace(/^\s+|\s+$|\s+(?=\s)/g, "")

			itemData.item_id = obj.product_code
			// if (obj.product_code.indexOf("WEB-") == 0) {
			// 	obj.product_code = obj.product_code.substring(0, obj.product_code.indexOf("_"));
			// }
			
			itemData.quantity = obj.qty
			itemData.index = i
			itemData.price = Number(obj.price)
			itemData.currency = cartData.currency
			
			itemsArray.push(itemData);
			i++;
			
			var is_first_premium = ((item.indexOf("_PREMIUM")!=-1 && obj.is_premium) ? true : false);
			var is_second_premium = ((item.indexOf("_PREMIUM")==-1 && obj.is_premium && obj.retail_price=='0.01') ? true : false);
			if (obj.shipping_required) {
				shipping_required = true;
			}
			
			var is_digital_product = ((item.indexOf("E-")==0) ? true : false);
			var digital_product_label = ((is_digital_product) ? '<span class="digital-product-label">Digital Product</span>' : '');
			
			//title 			
			var title = obj.checkout_title;
				if (window.location.hostname.indexOf('momentodecisivo')!=-1) {
					switch(obj.product_code.toUpperCase()) {
						case 'GIFT':
							title = 'Donación Generosa';
							break;
					}
				}
			var prod_note = '';
			if (is_first_premium) {
				var min_amount = ((obj.retail_price=='0.01') ? 'any amount' : mycart.currency_symbol + obj.retail_price.toString().replace('.00','') + ' or more');
				prod_note = 'For a gift of ' + min_amount;
				if (parseFloat(obj.price) < parseFloat(obj.retail_price)) {
					prod_note += ' (limit of 1)';
				}
				
				prod_note = '<span class="prod-note">' + prod_note + '</span>';
				title = prod_note + title;
			}
			if (is_digital_product) {
				title = digital_product_label + title;
			}
			
			title = title +((typeof obj.stamp!== 'undefined' && obj.stamp) ? '<span class="stamp">' + obj.stamp + '</span>' : '');

			title = title + ((typeof obj.details !== 'undefined' && obj.details) ? '<span class="details">' + obj.details + '</span>' : '');
			
			//cart note 
			if (obj.cart_note === 'undefined') obj.cart_note = '';
			if (obj.product_code.toLowerCase()=='apixmltr'
				|| obj.product_code.toLowerCase()=='apxmltr'
				|| obj.product_code.toLowerCase()=='bspxmltr'
				|| obj.product_code.toLowerCase()=='pcxmltr'
				|| obj.product_code.toLowerCase()=='vcxmltr'
				|| obj.product_code.toLowerCase().indexOf('sgr')==0) {
					//add jsb note 
					var day_of_month = '';
					var date_temp = new Date();
					if (date_temp.getDate() <= 15) {
						day_of_month = '5th';
					}
					else {
						day_of_month = '20th';
					}
					obj.cart_note = obj.cart_note.replace("{placeholder}", day_of_month);
				}
				
			switch(obj.product_code.toLowerCase()) {
				case 'apixmltr':
					if (obj.cart_note.indexOf('"incentive"')==-1) {
						obj.cart_note += '<div class="incentive"><div><img src="https://d2urhn0mmik6is.cloudfront.net/site/_images/monthly/0224/jsb-autopay/jsb-cart.png" alt="The Jeremiah Study Bible" title="The Jeremiah Study Bible" /></div><div>To thank you, we\'re including the standard print NKJV hardcover of <em>The Jeremiah Study Bible</em></div></div>';
					}	
					break;
			}
			
			if (obj.cart_note != '') {
				title = title + '<div class="prod-note">' + obj.cart_note + '</div>';
			}
			
			//price 
			var price = '' +
					'<span class="item-price">' + 
						((is_second_premium) ? '<a href="#" class="lnk-premium-policy" onclick="tp.showPremiumPolicy(); return false;"><i class="fa fa-question-circle" aria-hidden="true"></i></a> ' : '') +	
						mycart.currency_symbol + obj.price + 
					'</span>';
			if (parseFloat(obj.price) < parseFloat(obj.retail_price)) {
				price = '<span class="retail-price">' + mycart.currency_symbol + obj.retail_price + '</span> <span class="item-price sale-price">' + mycart.currency_symbol + obj.price + '</span>';
			}
			
			//price extended 
			var price_extended = '<span class="item-price">' + mycart.currency_symbol + obj.price_extended + '</span>';
			if (parseFloat(obj.price_extended) < parseFloat(obj.retail_price_extended)) {
				price_extended = '<span class="retail-price">' + mycart.currency_symbol + obj.retail_price_extended + '</span> <span class="item-price sale-price">' + mycart.currency_symbol + obj.price_extended + '</span>';
			}			
			
			//icon 
			if (obj.images == null) obj.images = {};
			var icon = ((typeof obj === 'object' && typeof obj.images === 'object' && typeof obj.images != null && typeof obj.images.icon !== 'undefined') ? '<img src="' + obj.images.icon + '" />' : '');
			
			var item_subtract = '<a href="#" class="subtract" onclick="mycart.addToCart(this, -1, {callback:function(){ mycart.showCart(); }}); return false;"><i class="fa fa-minus" aria-hidden="true"></i></a>';
			var item_add = '<a href="#" class="add" onclick="mycart.addToCart(this, 1, {callback:function(){mycart.showCart();}}); return false;"><i class="fa fa-plus" aria-hidden="true"></i></a>';
			var item_qty = '<input type="number" maxlength="2" class="input_qty" value="' + obj.qty + '" data-default-val="' + obj.qty + '" data-product-code="' + obj.product_code + '" />';
			
			//check for recurring
			//mycart.checkForRecurringGiving(item);
			
			//check for additional gift 
			mycart.checkForAdditionalGift();
			
			switch(obj.product_code.toLowerCase()) {
				case 'gift':
				case 'gift_tipjar':
				case 'apxmltr':
				case 'apixmltr':
					item_add = '';
					item_qty = '<div class="input_qty">1</div>';
					break;
				case '20actbl':
				case '21planbl':
				case '22planbl':
				case '23planbl':
			    case '24planbl':
				case 'e-easetjsb':
				case 'e-easetasg':
				case 'eassetasg':
					item_add = '';
					item_subtract = '';
					item_qty = '<div class="input_qty">' + obj.qty + '</div>';
					break;
			}
			if (is_first_premium) {
				//item_add = '';
				item_qty = '<div class="input_qty">1</div>';
			}
			if (typeof obj.cart_note !== 'undefined' && obj.cart_note.toLowerCase().indexOf("included as a thank-you")!=-1) {
				item_add = '';
				item_subtract = '';
				item_qty = '<div class="input_qty">1</div>';
			}
			
			//check for bsp discount 
			if (typeof obj.bsp_discount_applied !== 'undefined' && obj.bsp_discount_applied != '' && obj.bsp_discount_applied !== null) {
				if (!bsp_discount_applied) {
					bsp_discount_applied = obj.bsp_discount_applied;
				}
				
				if (typeof obj.bsp_prediscount_cache !== 'undefined' && obj.bsp_prediscount_cache !== null) {
					if (typeof obj.bsp_prediscount_cache.price !== 'undefined' && obj.bsp_prediscount_cache.price !== null && obj.bsp_prediscount_cache.price !== obj.price) {
						price = '<span class="strikethrough">' + mycart.currency_symbol + obj.bsp_prediscount_cache.price + '</span>' + price;
					}
				}
				if (typeof obj.bsp_prediscount_cache !== 'undefined' && obj.bsp_prediscount_cache !== null&& obj.bsp_prediscount_cache.price_extended !== obj.price_extended) {
					if (typeof obj.bsp_prediscount_cache.price_extended !== 'undefined' && obj.bsp_prediscount_cache.price_extended !== null) {
						price_extended = '<span class="strikethrough">' + mycart.currency_symbol + obj.bsp_prediscount_cache.price_extended + '</span>' + price_extended;
					}
				}
			}
			
			//check for coupon code 
			if (typeof obj.coupon_code_applied !== 'undefined' && obj.coupon_code_applied != '' && obj.coupon_code_applied !== null) {
				if (coupon_code_applied == '') {
					coupon_code_applied = obj.coupon_code_applied;
				}
				
				if (typeof obj.coupon_precode_cache !== 'undefined' && obj.coupon_precode_cache !== null) {
					if (typeof obj.coupon_precode_cache.price !== 'undefined' && obj.coupon_precode_cache.price !== null && obj.coupon_precode_cache.price !== obj.price) {
						price = '<span class="strikethrough">' + mycart.currency_symbol + obj.coupon_precode_cache.price + '</span>' + price;
					}
				}
				if (typeof obj.coupon_precode_cache !== 'undefined' && obj.coupon_precode_cache !== null&& obj.coupon_precode_cache.price_extended !== obj.price_extended) {
					if (typeof obj.coupon_precode_cache.price_extended !== 'undefined' && obj.coupon_precode_cache.price_extended !== null) {
						price_extended = '<span class="strikethrough">' + mycart.currency_symbol + obj.coupon_precode_cache.price_extended + '</span>' + price_extended;
					}
				}
			}	
			if (coupon_code_applied == null) coupon_code_applied = '';
		
			html += '' +
				'<tr class="bible' + ((is_first_premium) ? ' first-premium' : '') + '" data-productcode="' + obj.product_code + '">' + 
				'	<td class="img item-field">' + icon + '</td>' + 
				'	<td class="title item-field">' + title + '</td>' + 
				'	<td class="qty qty-field"><div class="input_wrapper">' + item_add + item_subtract + item_qty + '</div></td>' + 
				'	<td class="price currency-field">' + price + '</td>' + 
				'	<td class="price_extended currency-field">' + price_extended + '</td>' + 
				'</tr>' + 
			'';
		}
	}	
	
	if (cart_is_empty) {
		mycart.hideCart();
		alert('Your cart is currently empty.');
		return;
	}
	window.dataLayer = window.dataLayer || []
	dataLayer.push({ ecommerce: null });  // Clear the previous ecommerce object.

	let dataLayerData = { 
		"items": itemsArray
	};
	dataLayer.push({
		event: "view_cart",
		ecommerce: dataLayerData
	});
	
	var rush_shipping_notice = '';/*+
				'<div class="rush-shipping-notice">' +
					'<div class="icon"><i class="fa fa-align-right"></i><i class="fa fa-truck fa-flip-horizontal"></i></div>' +
                    '<div class="notice">' +
						'<h3>Rush Shipping</h3>' +
						'<a class="nostyle" href="/site/about/contact-us.aspx" target="_blank"><p class="left"><span class="underline">Click here to contact us</span> for expedited shipping options for the U.S., Canada, Australia, UK and New Zealand.</p></a>' +
					'</div>' +
				'</div>';*/
				
	//recurring upsell 
	var recurring_upsell = '' +
		'<div class="recurring-option">' +
		'	<h2>Would you like to give monthly to Turning Point?</h2>' +
		'	<div class="options">' +
		'		<div class="opt"><a href="#" class="opt-recurring-yes" onclick="mycart.selectRecurringOption(this); return false;"><i class="fa fa-circle-o radio-btn" aria-hidden="true"></i>&nbsp; Yes, I will give monthly</a> &nbsp;<i class="fa fa-info-circle" aria-hidden="true" onclick="mycart.showRecurringPopup(); return false;"></i></div>' +
		'		<div class="enter-amount currency-' + mycart.currency.toLowerCase() + '">' +
		'			<span class="currency-symbol">' + mycart.currency_symbol + '</span>' +
		'			<input type="text" id="input_recurring_amount" />' +
		'			<a href="#" class="btn-add-recurring" onclick="mycart.addRecurringGiftToCart(); return false;">Add to Cart</a>' +
		'		</div>' +
		'		<div class="opt"><a href="#" class="opt-recurring-no" onclick="mycart.selectRecurringOption(this); return false;"><i class="fa fa-circle-o radio-btn" aria-hidden="true"></i>&nbsp; No, thanks</a></div>' +
		'	</div>' +
		'</div>';
	if (!mycart.show_recurring_option) {
		recurring_upsell = '';
	}
	
	//additional gift ask 
	var additional_gift = '' +
		'<div class="additionalgift-option">' +
		'	<div class="processing"><i class="fa fa-cog fa-spin" aria-hidden="true"></i></div>' +
		'	<div class="inner">' +
			'	<h2>Would you like to make an additional donation to Turning Point?</h2>' +
			'	<div class="options">' +
			'		<div class="opt"><a href="#" class="opt-additionalgift-yes" onclick="mycart.selectAdditionalGiftOption(this); return false;"><i class="fa fa-circle-o radio-btn" aria-hidden="true"></i>&nbsp; Yes</a></div>' +
			'		<div class="enter-amount currency-' + mycart.currency.toLowerCase() + '">' +
			'			<span class="currency-symbol">' + mycart.currency_symbol + '</span>' +
			'			<input type="text" id="input_additionalgift_amount" />' +
			'			<a href="#" class="btn-add-additionalgift" onclick="mycart.addAdditionalGiftToCart(); return false;">Add to Cart</a>' +
			'		</div>' +
			'		<div class="opt"><a href="#" class="opt-additionalgift-no" onclick="mycart.selectAdditionalGiftOption(this); return false;"><i class="fa fa-circle-o radio-btn" aria-hidden="true"></i>&nbsp; No, thanks</a></div>' +
			'	</div>' +
		'	</div>' +
		'	<div class="inner-right"></div>' +
		'</div>';
	if (!mycart.show_additional_gift) {
		additional_gift = '';
	}
	
	var coupon_code = '' +
		'<div class="coupon_code">' +
			'<p><strong>Have an offer code?</strong><br/>You can apply it on the checkout screen!</p>' +
		'</div>';

	if (!mycart.cart_has_purchase_item || coupon_code_applied!='') {
		coupon_code = '';
		if (coupon_code_applied!='') {
			coupon_code = '<div class="coupon_code"><div class="coupon_code_success" style="display:block;"><i class="fa fa-check" aria-hidden="true"></i> Offer Code <strong>' + coupon_code_applied.toUpperCase() + '</strong> has been applied.</div></div>';
		}
	}
	
		
	//international overrides 
	var amount_currency_symbol = mycart.currency_symbol;
	switch(window.location.hostname) {
		case 'www.momentodecisivo.org':
		case 'dev.momentodecisivo.org':
			amount_currency_symbol = '';
			break;
	}
	
	html = '' +
		'<div class="my_cart_bg" onclick="mycart.hideCart();"></div>' +
		'<div class="my_cart_content">' +
			'<a href="#" class="btn_close" onclick="mycart.hideCart(); return false;"><i class="fa fa-times" aria-hidden="true"></i></a>' +
			'<div class="my_cart_contents_inner">' +
				'<div class="my_cart_top">' +
				'	<h1><i class="fa fa-shopping-cart"></i> ' + settings.headline + '</h1>' +
				'	<h2>Review Your Order</h2>' +
				'	<p class="shipping-next-page">(' + ((shipping_required) ? 'shipping & ' : '') + 'billing information will be collected on the next page)</p>' +				'</div>' +
				christmas_shipping_banner + 
				'<div class="my_cart_items">' +
					'<table class="tbl_my_cart">' +
					'	<tr>' +
					'		<th></td>' +
					'		<th class="item-field">Item</th>' +
					'		<th class="qty-field">Qty</th>' +
					'		<th class="currency-field">' + amount_currency_symbol + 'Amt.</th>' +
					'		<th class="currency-field item-tot">Item Tot.</th>' +
					'	</tr>' +
					'	' + html + 
					'</table>' +
					additional_gift +
				'</div>' +
				'<div class="my_cart_totals">' +
					'<div class="sub_total_wrapper' + ((coupon_code=='') ? ' one-col' : '') + '">' +
						coupon_code + 
						'<table class="tbl_my_cart_totals">' +
						'	<tr>' +
						'		<td class="label sub-total">Sub-Total: </td>' +
						'		<td class="currency-field sub-total">' + mycart.currency_symbol + mycart.cart.subtotal + '</td>' +
						'	</tr>' +
						'	<!--<tr>' +
						'		<td colspan="2">(applicable CA sales tax will be added on the next page)</td>' +
						'	</tr>-->' +
						'</table>' +
					'</div>' +
					'<div class="currency-selector">' +
						mycart.currency_selector +
					'</div>' +
				'</div>' +
				
				'<div class="my_cart_btns">' +
					'<a href="#" class="btn-continue-shopping" onclick="mycart.hideCart(); return false;"><i class="fa fa-caret-left" aria-hidden="true"></i> <span>Go Back</span></a>' +
					'{btns}' +
				'</div>' +
				'<div class="oneclick-notice">{oneclick_notice}</div>' +
                ((shipping_required) ? rush_shipping_notice : '') + 
			'</div>' +
		'</div>' +
	'';
	
	var cart_already_open = false;
	if ($('#my_cart').length>0 && $('#my_cart').css('display')=='block') {
		cart_already_open = true;
	}
	
	if ($('#my_cart').length==0) {
		$('body').prepend('<div id="my_cart"></div>');
	}
	
	var btns = '<a href="#" class="btn-continue" onclick="mycart.goToCheckout(); return false;"><i class="fa fa-lock"></i> Continue</a>';
	var oneclick_notice = '';

	if (settings.oneclick_checkout && typeof tp.payment_methods[0] !== 'undefined') {
		var default_pm = tp.payment_methods[0];
		btns = '<a href="#" class="btn-continue" onclick="mycart.placeOrder(); return false;"><i class="fa fa-lock"></i> Place My Order</a>';
		oneclick_notice = '<span><img src="' + default_pm.card_icon + '" /> Your ' + default_pm.card_type + ' ending in ' + default_pm.last4 + ' will be charged.';
		$('#my_cart').addClass('oneclick');
	}
	else {
		$('#my_cart').removeClass('oneclick');
	}
	
	html = html.replace('{btns}', btns)
			   .replace('{oneclick_notice}', oneclick_notice);	
	
	$('#my_cart').html(html).show();
	
	//ensure currency selector shows the currently-selected currency 
	tp.selectCurrency(mycart.currency, mycart.currency_symbol);
	
	//set input event listeners 
	$('.input_qty').off('blur').on('blur', function() {
		var default_val = $(this).attr('data-default-val');
		var val = $(this).val();
		
		if (parseFloat(val) > mycart.max_qty) {
			$(this).val(default_val);
		}
		
		if (val != default_val) {
			mycart.addToCart(this, val, {
				replace_qty: true, 
				callback: function() {
					mycart.showCart();
				}
			});
		}
	}).on('focus', function(){
		$(this).select();
	});
	
	if ($('#input_additionalgift_amount').length>0) {
		$('#input_additionalgift_amount').on('keyup', function(e) {
			if (e.keyCode==13) {
				mycart.addAdditionalGiftToCart(); 
				return false;
			}
		});
	}
	
	if (coupon_code!='') {
		$('#my_cart .input_coupon_code').on('keyup', function(e) {
			if (e.keyCode==13) {
				mycart.applyCouponCode();
			}
		});
	}
	
	setTimeout(function() {
		$('#my_cart').addClass('visible');
	}, 100);
	
	
	//hide fixed footer 
	$('#cart_footer .inner').addClass('minfoot');
	

	if (!cart_already_open) {
		//get scrollbar width 
		var scrollbar_width = (window.outerWidth - $(window).width());
		var adjusted_page_width = (window.outerWidth - scrollbar_width);
		var fixed_elems = $('*').filter(function () { 
								return $(this).css('position') == 'fixed';
							});
		
		//hide window scrollbar 
		$('body').css({'overflow':'hidden'});	
		$('body, .header-container').css({'max-width':adjusted_page_width});
		$(fixed_elems).each(function() {
			var id = $(this).attr('id');
			if (id!='my_cart') {
				$(this).css({'max-width':adjusted_page_width});
			}
		});
	}
	else {
		$('body').css({'overflow':'hidden'});	
	}
}

mycart.toggleCouponCodeForm = function(force_action) {
	var visible = (( $("#my_cart .coupon_code .form").css("display")=="none" ) ? false : true);
	if (typeof force_action !== 'undefined') {
		switch(force_action) {
			case 'show':
				visible = false;
				break;
			case 'hide':
				visible = true;
				break;
		}
	}
	
	if (!visible) {
		/*
		$("#my_cart .coupon_code .form").show();
		$("#my_cart .btn-show-coupon-code").hide();
		$("#my_cart .coupon_code .form input[type=text]").focus();
		*/
		
		$('#my_cart .btn-show-coupon-code').addClass('hidden');
		
		setTimeout(function() {
			$('#my_cart .btn-show-coupon-code').hide();
			$("#my_cart .coupon_code .form").show();
			setTimeout(function() {
				$("#my_cart .coupon_code .form").removeClass('hidden');
			}, 20);
			$("#my_cart .coupon_code .form input[type=text]").focus();
		}, 200);

	}
	else {
		$("#my_cart .coupon_code .form").hide();
		$("#my_cart .btn-show-coupon-code").show();
	}
}


mycart.placeOrder = function() {
	
}

mycart.hideCart = function() {
	
	$('#my_cart').removeClass('full-screen');

	//hide cart 
	$('#my_cart').removeClass('visible');
	setTimeout(function() {
		$('#my_cart').fadeOut(200);
	}, 250);
	
	//show fixed footer 
	$('#cart_footer .inner').removeClass('minfoot');
	
	//show window scrollbar
	$('body').css({'overflow':'visible'});
	$('body, .header-container').css({'max-width':'100%'});
	
	var fixed_elems = $('*').filter(function () { 
							return $(this).css('position') == 'fixed';
						});	
	$(fixed_elems).each(function() {
		var id = $(this).attr('id');
		if (id!='my_cart') {
			$(this).css({'max-width':'none'});
		}
	});						
}

mycart.setCurrency = function(currency, callback, settings) {
	if (typeof callback === 'undefined' || callback=='') callback = function(){};
	if (typeof settings === 'undefined') settings = {};
	if (typeof settings.use_ajax === 'undefined') settings.use_ajax = true;
	if (typeof settings.currency_symbol === 'undefined') settings.currency_symbol = '$';
	
	mycart.currency = currency;
	mycart.currency_symbol = settings.currency_symbol;
	
	//currency symbol fallback 
	if (mycart.currency_symbol == '') {
		switch(mycart.currency) {
			case "CAD":
				mycart.currency_symbol = 'CAD $';
				break;
			case "USD":
				mycart.currency_symbol = '$';
				break;
				
		}
	}
	
	if (settings.use_ajax) {
		var o = {};
			o.cart_id = mycart.cart.cart_id;
			o.currency = mycart.currency;
		$.post('/api/store/set_cart_currency', o, function(data) {
			//console.log(data);
		});	
	}
	
	callback();
}

mycart.setCurrencyFromCart = function(elem) {
	var currency = $(elem).attr("data-currency");
	var currency_symbol = $(elem).attr("data-currency-symbol");
	mycart.setCurrency(currency, function() { mycart.showCart(); }, {currency_symbol:currency_symbol});
}

mycart.goToCheckout = function(settings) {
	if (typeof settings === 'undefined') settings = {};
	if (typeof settings.skip_upsell === 'undefined') settings.skip_upsell = false;
	if (!mycart.show_recurring_option) settings.skip_upsell = true;
	

	/*
	if (!settings.skip_upsell) {
		//show upsell for recurring giving 
		
		var amount = '40.00';
		if (typeof mycart.cart.contents.GIFT !== 'undefined') {
			amount = mycart.cart.contents.GIFT.price;
		}		
		amount = mycart.currency_symbol + amount;
		
		var html = '<div class="recurring-upsell">' +
			'<h1>Steve, would you consider converting Your gifts into an ongoing <span class="highlight">monthly gift</span>?</h1>' +
			'<p>By partnering with Turning Point in monthly giving, you\'ll help us continue to reach millions of people in 48 countries as we <em>deliver the unchanging Word of God to an ever-changing world</em>.</p>' +
			'<div class="btns">' +
			'	<a href="#" class="btn-recurring-yes" onclick="return false;">Yes!<span class="sm">Convert my gift to a ' + amount + ' monthly gift</span></a>' +
			'	<a href="#" class="btn-recurring-no" onclick="mycart.goToCheckout({skip_upsell:true}); return false;">No, thanks<span class="sm">Process my original one-time gift</span></a>' +
			'</div>' +
		'</div>';
		
		$('#my_cart').addClass('full-screen');
		$('.my_cart_contents_inner').animate({'opacity':0}, 100, function() {
			$('.my_cart_contents_inner').addClass('full-height').html(html);
			$(this).animate({'opacity':1}, 200);
		});
		
		
	}
	else {
	*/
		var d = tp.getQueryStringValue("devdate");
		var url = '/checkout?c=' + mycart.currency + ((d!="") ? '&devdate=' + d : '');
		
		var hostname = location.hostname;
		
		switch(mycart.currency.toLowerCase()) {
			default:
			case 'usd':
				if (location.hostname.indexOf("davidjeremiah.org")==-1 && location.hostname.indexOf("momentodecisivo.org")==-1) {
					tp.clearCartCookie({clear_tid:"true"});
					url = 'https://www.davidjeremiah.org' + url + '&cart=Nzc0NzMxMDMz&session=' + tp.tid_id;
				}
				break;
			case 'cad':
				if (location.hostname.indexOf("davidjeremiah.ca")==-1) {
					tp.clearCartCookie({clear_tid:"true"});
					url = 'https://www.davidjeremiah.ca' + url + '&cart=Nzc0NzMxMDMz&session=' + tp.tid_id;
				}
				break;
			case 'gbp':
				if (location.hostname.indexOf("davidjeremiah.co.uk")==-1) {
					tp.clearCartCookie({clear_tid:"true"});
					url = 'https://www.davidjeremiah.co.uk' + url + '&cart=Nzc0NzMxMDMz&session=' + tp.tid_id;
				}
				break;
		}

		window.location.href = url;
	/*
	}
	*/
}

mycart.show_additional_gift = true;
mycart.show_recurring_option = true;
mycart.toggleRecurringAmount = function(force_action) {
	var visible = (($('.enter-amount').css("display")=="none") ? false : true);
	var action = 'show';
	switch(visible) {
		case true:
			action = 'hide';
			break;
		case false:
			action = 'show';
			break;
	}
	if (typeof force_action !== 'undefined') {
		action = force_action;
	}
	
	if (action == 'show') {
		$('.enter-amount').slideDown(200, function() {
			$(this).find('input[type=text]').focus();
		});
	}
	else {
		$('.enter-amount').slideUp(200);
	}
}

mycart.selectRecurringOption = function(elem) {
	var val = (($(elem).hasClass("opt-recurring-yes")) ? 'yes' : 'no');
	switch(val) {
		case 'yes':
			$('.opt-recurring-yes .radio-btn').removeClass('fa-circle-o').addClass('fa-check-circle');
			$('.opt-recurring-no .radio-btn').addClass('fa-circle-o').removeClass('fa-check-circle');
			mycart.toggleRecurringAmount('show');
			break;
		case 'no':
			$('.opt-recurring-no .radio-btn').removeClass('fa-circle-o').addClass('fa-check-circle');
			$('.opt-recurring-yes .radio-btn').addClass('fa-circle-o').removeClass('fa-check-circle');		
			mycart.toggleRecurringAmount('hide');
			break;
	}
}

mycart.showRecurringPopup = function() {
	var html = '' +
		'<h2>Monthly Giving</h2>' +
		'<p>By partnering with Turning Point in monthly giving, you\'ll help us continue to reach millions of people in 48 countries as we <em>deliver the unchanging Word of God to an ever-changing world</em>.</p>' +
		'<p>The donation you make today will recur monthly, and you can cancel anytime.</p>' +		
	'';
	alert(html);
}

mycart.addRecurringGiftToCart = function() {
	var o = {};
	o.amount = $('#input_recurring_amount').val();
	
	tp.addToCart('APXMLTR', 1, {
		replace_qty: true,
		custom_price: o.amount,
		currency: mycart.currency,
		callback: function(data) {
			mycart.cart = data;
			mycart.showCart();
		}
	});
}

mycart.checkForRecurringGiving = function(item) {
	return false;
	item = item.replace("_PREMIUM", "");
	
	switch(item.toUpperCase()) {
		case "APXMLTR":
		case "APIXMLTR":
			mycart.show_recurring_option = false;
			break;
	}
}

/*
mycart.checkForAdditionalGift = function(item) {
	item = item.replace("_PREMIUM", "");
	
	switch(item.toUpperCase()) {
		case "GIFT":
			mycart.show_additional_gift = false;
			break;
		case "APXMLTR":
		case "AGAPXMLTR":
			mycart.show_additional_gift = false;
			mycart.show_recurring_option = false;
			break;
	}
}
*/

mycart.cart_has_donation = false;
mycart.cart_has_recurring_donation = false;
mycart.cart_has_purchase_item = false;

mycart.checkForAdditionalGift = function() {
	var cart_has_donation = false;
	var cart_has_recurring_donation = false;
	var cart_has_purchase_item = false;
	var cart_has_tip = false;
	var contents = mycart.cart.contents;
	
	for (var item in contents) {
		if (contents.hasOwnProperty(item)) {
			var obj = contents[item];
			var product_code = obj.product_code.toLowerCase();
				product_code = product_code.replace('_premium', '');
			var page_origin = ((typeof obj.page_origin !== 'undefined') ? obj.page_origin : '');
			
			if (product_code=='gift') {
				cart_has_donation = true;
			}
			else if (product_code=='gift_tipjar') {
				cart_has_donation = true;
				cart_has_tip = true;
			}
			else if (product_code=='apxmltr'
				|| product_code=='apixmltr'
				|| product_code=='agapxmltr'
				|| product_code=='bspxmltr'
				|| product_code=='pcxmltr'
				|| product_code=='vcxmltr'
				|| product_code.substring(0,3) == 'sgr'
				|| obj.is_premium) {
					cart_has_donation = true;
					cart_has_recurring_donation = true;
			}
			else if (parseInt(obj.price) == 0) {
				cart_has_purchase_item = false;
			}
			else {
				cart_has_purchase_item = true;
			}
		}
	}
	
		
	//additional gift 
	if (cart_has_donation) {
		mycart.show_additional_gift = false;
	}
	else {
		mycart.show_additional_gift = true;
	}
	
	//recurring option 
	if (cart_has_recurring_donation) {
		mycart.show_recurring_option = false;
	}
	else {
		mycart.show_recurring_option = true;
	}
	
	//globals 
	mycart.cart_has_donation = cart_has_donation;
	mycart.cart_has_recurring_donation = cart_has_recurring_donation;
	mycart.cart_has_purchase_item = cart_has_purchase_item;
}

mycart.selectAdditionalGiftOption = function(elem) {
	var val = (($(elem).hasClass("opt-additionalgift-yes")) ? 'yes' : 'no');
	switch(val) {
		case 'yes':
			$('.opt-additionalgift-yes .radio-btn').removeClass('fa-circle-o').addClass('fa-check-circle');
			$('.opt-additionalgift-no .radio-btn').addClass('fa-circle-o').removeClass('fa-check-circle');
			mycart.toggleAdditionalGiftAmount('show');
			break;
		case 'no':
			$('.opt-additionalgift-no .radio-btn').removeClass('fa-circle-o').addClass('fa-check-circle');
			$('.opt-additionalgift-yes .radio-btn').addClass('fa-circle-o').removeClass('fa-check-circle');		
			mycart.toggleAdditionalGiftAmount('hide');
			break;
	}
}

mycart.toggleAdditionalGiftAmount = function(force_action) {
	var visible = (($('.enter-amount').css("display")=="none") ? false : true);
	var action = 'show';
	switch(visible) {
		case true:
			action = 'hide';
			break;
		case false:
			action = 'show';
			break;
	}
	if (typeof force_action !== 'undefined') {
		action = force_action;
	}
	
	if (action == 'show') {
		$('.enter-amount').slideDown(200, function() {
			$(this).find('input[type=text]').focus();
		});
	}
	else {
		$('.enter-amount').slideUp(200);
	}
}

mycart.addAdditionalGiftToCart = function() {
	var amount = parseFloat($('#input_additionalgift_amount').val().replace(',', ''));
	if (isNaN(amount) || amount<=0.01) {
		alert('Please enter a valid amount.');
		return;
	}
	
	$('.additionalgift-option').addClass('in-progress');
	
	var page_url = window.location.pathname + tp.removeQueryStringValue('origin', window.location.search);
	var origin = 'cart-inc-pure';
	
	page_url += ((page_url.indexOf("?")==-1) ? '?' : '&') + "origin=" + origin;
	
	tp.addToCart('GIFT_TIPJAR', 1, {
		custom_price: amount,
		replace_qty: true,
		page_url: page_url,
		exclude_page: true,
		callback: function(data) {
			mycart.cart = data;
			mycart.updateCart();
			mycart.showCart();
		}
	});
}

mycart.apply_coupon_code_inprogress = false;
mycart.applyCouponCode = function() {
	if (mycart.apply_coupon_code_inprogress) return;
	mycart.apply_coupon_code_inprogress = true;
	
	var coupon_code = $('.input_coupon_code').val();
	tp.applyCouponCode(coupon_code, {
		onerror: function(data) {
			$('#my_cart .coupon_code_success').hide();
			$('#my_cart .coupon_code_error').html('Please enter a valid offer code.').slideDown(200);
		},
		onsuccess: function(data) {
			mycart.cart = data.cart;
			mycart.updateCart();
			mycart.showCart();
			$('#my_cart .coupon_code .form').hide();
			$('#my_cart .coupon_code_error').hide();
			var freeShippingText = '';
			if(typeof data.cart.coupon_code !== 'undefined' && typeof data.cart.coupon_code.discount_type !== 'undefined'){
				if(data.cart.coupon_code.discount_type.indexOf('free_shipping') != -1){
					freeShippingText = '<br/>Your Free Shipping will be reflected on the next screen.';
				}
			}
			$('#my_cart .coupon_code_success').html('<i class="fa fa-check" aria-hidden="true"></i> Offer Code <strong>' + coupon_code.toUpperCase() + '</strong> has been applied.' + freeShippingText).show();
		},
		oncomplete: function(data) {
			mycart.apply_coupon_code_inprogress = false;
		}
	});
}